# dockward 

Port forwarding tool for Docker containers. 

![Demonstration](https://github.com/abiosoft/dockward/blob/master/dockward.gif)

Typical Dockward use cases include:
* Port forwarding to containers without published ports.
* Port forwarding to containers based on a filter.
* Testing stateless app scaled via docker-compose.

## Requirements
Docker 1.10 and docker deamon running.

## Installation

### Homebrew (OSX only)
```sh
brew install dockward
```

### Binary
Download binary for other platforms on the [releases](https://github.com/abiosoft/dockward/releases) page or replace download link accordingly for OSX.
```sh
curl -LO https://github.com/abiosoft/dockward/releases/download/0.0.4/dockward_linux_amd64.tar.gz \
&& tar xvfz dockward_linux_amd64.tar.gz \
&& sudo mv dockward_linux_amd64 /usr/local/bin/dockward \
&& sudo chmod +x /usr/local/bin/dockward
```

### Source
Requires Go.
```sh
go get -v -u github.com/abiosoft/dockward
```

## Usage
Note: If dockward is not running on Linux or docker host, you will access it via docker host ip (e.g. dockermachine ip). Except `--host` mode.

Forward port `8080` to port `8080` in container `amazing_leavitt`.
```sh
dockward 8080 name=amazing_levitt
```
Forward port `8080` to port `80` in containers with label `type=nginx`.
```sh
dockward 8080 80 label=type=nginx
```
Forward port `8080` to a local port `3000`.
```sh
dockward --host 8080 3000
```
Forward port `8080` to endpoints `127.0.0.1:3000` and `127.0.0.1:3001`.
```sh
dockward --host 8080 127.0.0.1:3000 127.0.0.1:3001
```
For more.
```
dockward --help
```

## Limitations
* Dockward is intended for simple local development use cases. It may work for you outside of that.
* Docker networks created are default settings i.e. bridge/overlay as the case may be. Nothing special.

## Why the name ?
Naming is hard, you know.

**Dock**erFor**ward**, port **forwarding** tool for **docker** containers.

## License
Apache 2